<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Tasks &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Abstract types" href="heiwa.types.html" />
    <link rel="prev" title="Rate limiter" href="heiwa.limiter.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.html">API views</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
      <li>Tasks</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.tasks.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.tasks">
<span id="tasks"></span><h1>Tasks<a class="headerlink" href="#module-heiwa.tasks" title="Permalink to this headline"></a></h1>
<p>Sheduled tasks.</p>
<dl class="py class">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">SchedulerService</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">scheduler</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">apscheduler.schedulers.base.BaseScheduler</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService" title="Permalink to this definition"></a></dt>
<dd><p>An RPyC service used to communicate with and handle an APScheduler from
another program.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Adapted from an <a class="reference external" href="https://github.com/agronholm/apscheduler/com mit/19fa2fa27a7e168fbcec883817408a21a8b7339e">example</a> by
<a class="reference external" href="https://github.com/agronholm">Alex Grönholm</a>.</p>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.__init__">
<span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">scheduler</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">apscheduler.schedulers.base.BaseScheduler</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.__init__"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Assigns the <code class="docutils literal notranslate"><span class="pre">scheduler</span></code> to <code class="docutils literal notranslate"><span class="pre">self</span></code>, then runs the superclass’
<code class="docutils literal notranslate"><span class="pre">__init__</span></code> method.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>scheduler</strong> – The scheduler to operate on.</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.__weakref__">
<span class="sig-name descname"><span class="pre">__weakref__</span></span><a class="headerlink" href="#heiwa.tasks.SchedulerService.__weakref__" title="Permalink to this definition"></a></dt>
<dd><p>list of weak references to the object (if defined)</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.add_job">
<span class="sig-name descname"><span class="pre">add_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">func</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Callable</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.add_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.add_job" title="Permalink to this definition"></a></dt>
<dd><p>Adds a job to the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>func</strong> – The function to execute.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.get_job">
<span class="sig-name descname"><span class="pre">get_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.get_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.get_job" title="Permalink to this definition"></a></dt>
<dd><p>Finds a job in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code> by
its ID.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>job_id</strong> – The ID of the job.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The job.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.get_jobs">
<span class="sig-name descname"><span class="pre">get_jobs</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.get_jobs"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.get_jobs" title="Permalink to this definition"></a></dt>
<dd><p>Gets all jobs in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>jobstore</strong> – Where and how the jobs are stored. Optional.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The jobs.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.modify_job">
<span class="sig-name descname"><span class="pre">modify_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">changes</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.modify_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.modify_job" title="Permalink to this definition"></a></dt>
<dd><p>Modifies a job in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>job_id</strong> – The ID of the job.</p></li>
<li><p><strong>jobstore</strong> – Where and how the job is stored. Optional.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.pause_job">
<span class="sig-name descname"><span class="pre">pause_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.pause_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.pause_job" title="Permalink to this definition"></a></dt>
<dd><p>Pauses a job in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>job_id</strong> – The ID of the job.</p></li>
<li><p><strong>jobstore</strong> – Where and how the job is stored. Optional.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.remove_job">
<span class="sig-name descname"><span class="pre">remove_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.remove_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.remove_job" title="Permalink to this definition"></a></dt>
<dd><p>Removes a job from the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>job_id</strong> – The ID of the job.</p></li>
<li><p><strong>jobstore</strong> – Where and how the job is stored. Optional.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.reschedule_job">
<span class="sig-name descname"><span class="pre">reschedule_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">trigger</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">apscheduler.triggers.base.BaseTrigger</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">trigger_args</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.reschedule_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.reschedule_job" title="Permalink to this definition"></a></dt>
<dd><p>Reschedules a job in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>job_id</strong> – The ID of the job.</p></li>
<li><p><strong>jobstore</strong> – Where and how the job is stored. Optional.</p></li>
<li><p><strong>trigger</strong> – Which trigger determines when the function is run. Optional.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.tasks.SchedulerService.resume_job">
<span class="sig-name descname"><span class="pre">resume_job</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">job_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">jobstore</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/tasks.html#SchedulerService.resume_job"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.SchedulerService.resume_job" title="Permalink to this definition"></a></dt>
<dd><p>Resunes a job in the <code class="xref py py-attr docutils literal notranslate"><span class="pre">scheduler</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>job_id</strong> – The ID of the job.</p></li>
<li><p><strong>jobstore</strong> – Where and how the job is stored. Optional.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the function call to do so.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.delete_expired_guest_users">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">delete_expired_guest_users</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#delete_expired_guest_users"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.delete_expired_guest_users" title="Permalink to this definition"></a></dt>
<dd><p>Deletes all <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a>s who have been registered
by the <a class="reference internal" href="heiwa.views.guest.html#module-heiwa.views.guest" title="heiwa.views.guest"><code class="xref py py-mod docutils literal notranslate"><span class="pre">guest</span></code></a> API and have not made any content
visible to external parties - the conditions for which are defined in
<a class="reference internal" href="heiwa.database.html#heiwa.database.User.has_content" title="heiwa.database.User.has_content"><code class="xref py py-attr docutils literal notranslate"><span class="pre">User.has_content</span></code></a>. For those who do
have visible content, the
<code class="xref py py-attr docutils literal notranslate"><span class="pre">external_identifier</span></code>
containing a hashed IP address is set to <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config</strong> – The concerned Flask app’s config.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To allow for easy hashing, the actual <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code>
instance is not provided.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Since all guest users without content have been deleted after the first
query, the second does not include needing to have content as a
condition.</p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.delete_expired_thread_view_records">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">delete_expired_thread_view_records</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#delete_expired_thread_view_records"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.delete_expired_thread_view_records" title="Permalink to this definition"></a></dt>
<dd><p>Deletes all <a class="reference internal" href="heiwa.database.html#heiwa.database.ThreadViewRecord" title="heiwa.database.ThreadViewRecord"><code class="xref py py-class docutils literal notranslate"><span class="pre">ThreadViewRecord</span></code></a>
objects whose age exceeds the amount of seconds defined in the
<code class="docutils literal notranslate"><span class="pre">THREAD_VIEW_COOLDOWN</span></code> config key.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config</strong> – The concerned Flask app’s config.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To allow for easy hashing, the actual <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code>
instance is not provided.</p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.delete_expired_user_bans">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">delete_expired_user_bans</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#delete_expired_user_bans"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.delete_expired_user_bans" title="Permalink to this definition"></a></dt>
<dd><p>Sets the <a class="reference internal" href="heiwa.database.html#heiwa.database.User.is_banned" title="heiwa.database.User.is_banned"><code class="xref py py-attr docutils literal notranslate"><span class="pre">is_banned</span></code></a> attribute of
all <code class="xref py py-class docutils literal notranslate"><span class="pre">User</span> <span class="pre">&lt;heiwa.database.User&gt;`s</span> <span class="pre">whose</span> <span class="pre">ban</span> <span class="pre">has</span> <span class="pre">expired</span> <span class="pre">to</span>
<span class="pre">:data:`False</span></code>, if theirs is still <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>. This will also happen
automatically, should they use any API endpoint where they’ve authenticated.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config</strong> – The concerned Flask app’s config.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To allow for easy hashing, the actual <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code>
instance is not provided.</p>
</div>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.html#heiwa.database.UserBan" title="heiwa.database.UserBan"><code class="xref py py-class docutils literal notranslate"><span class="pre">heiwa.database.UserBan</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.delete_unverified_expired_local_accounts">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">delete_unverified_expired_local_accounts</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#delete_unverified_expired_local_accounts"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.delete_unverified_expired_local_accounts" title="Permalink to this definition"></a></dt>
<dd><p>Deletes all <a class="reference internal" href="heiwa.database.html#heiwa.database.LocalAccount" title="heiwa.database.LocalAccount"><code class="xref py py-class docutils literal notranslate"><span class="pre">LocalAccount</span></code></a>s that
have existed for longer than
<code class="docutils literal notranslate"><span class="pre">config-&gt;LOCAL_ACCOUNT_VERIFICATION_JWT_EXPIRES_AFTER</span></code> seconds and whose
<a class="reference internal" href="heiwa.database.html#heiwa.database.LocalAccount.email_is_verified" title="heiwa.database.LocalAccount.email_is_verified"><code class="xref py py-attr docutils literal notranslate"><span class="pre">email_is_verified</span></code></a>
attribute is <code class="xref py py-data docutils literal notranslate"><span class="pre">False</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config</strong> – The concerned Flask app’s config.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To allow for easy hashing, the actual <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code>
instance is not provided.</p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.get_scheduler">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">get_scheduler</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config:</span> <span class="pre">typing.Dict</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">scheduler_class:</span> <span class="pre">apscheduler.schedulers.base.BaseScheduler</span> <span class="pre">=</span> <span class="pre">&lt;class</span> <span class="pre">'apscheduler.schedulers.background.BackgroundScheduler'&gt;</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">apscheduler.schedulers.base.BaseScheduler</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">bool</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#get_scheduler"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.get_scheduler" title="Permalink to this definition"></a></dt>
<dd><p>Generates a scheduler based on the given Flask app config containing
informabion about when to perform certain tasks.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>config</strong> – The Flask app’s config.</p></li>
<li><p><strong>scheduler_class</strong> – The scheduler class to use. <code class="xref py py-class docutils literal notranslate"><span class="pre">BackgroundScheduler</span></code> by default.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The scheduler.</p>
</dd>
</dl>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>The scheduler’s timezone is set to UTC. Real world timezones can be
messy and break things in unexpected ways, avoiding the possible confusion
with setup isn’t of extreme importance either.</p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.tasks.log_statistics">
<span class="sig-prename descclassname"><span class="pre">heiwa.tasks.</span></span><span class="sig-name descname"><span class="pre">log_statistics</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">config</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/tasks.html#log_statistics"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.tasks.log_statistics" title="Permalink to this definition"></a></dt>
<dd><p>As long as it’s not the exact same as the previous record, creates a
<a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic" title="heiwa.database.Statistic"><code class="xref py py-class docutils literal notranslate"><span class="pre">Statistic</span></code></a> object with the current
thread, post and user count.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config</strong> – The concerned Flask app’s config.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To allow for easy hashing, the actual <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code>
instance is not provided.</p>
</div>
</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.limiter.html" class="btn btn-neutral float-left" title="Rate limiter" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.types.html" class="btn btn-neutral float-right" title="Abstract types" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>